// M.Graziani - Calcola forme d'onda come in Csound GEN 10
//

// inlets and outlets
inlets = 1;
outlets = 4;

// globals

var hfun = new Array(513);	// 512 + guard point for interpolation
var hamp = new Array(500);	// harm amp (max 500 harms)
var pi = 3.1415926535897932384626433832795;
var step = 2*pi/512.;
var hnum = 0;

// bang
function bang(x)
{
	for (i = 0; i < 513; i++)	// out
	{
		outlet (1, hfun[i]);
		outlet (0, i);
	}

	outlet (2, "doneout");
}

// table
function table(val)
{
	var xpos = 0.0, vmax = 0.0;
	var i, j, sum;
	
	j = arguments.length;
	
	if (!j) // no arguments
	{
		this.error("table with no values");
		post();
		return;
	}

	hnum = j;
	
	for (j = 0; j < hnum; j++)	// save harm amplitudes
		hamp[j] = arguments[j];
	
	for (i = 0; i < 512; i++)	// calc function values
	{
		hfun[i] = 0.0;
		for (j = 0; j < hnum; j++)
			hfun[i] += Math.sin(xpos*(j+1)) * hamp[j];

		if (hfun[i] > vmax) vmax = hfun[i];
		xpos += step;
	}

	for (i = 0; i < 512; i++)	// rescaling
		hfun[i] = hfun[i] / vmax;
		
	hfun[512] = hfun[0];		// set guard point

	outlet (2, "donetable");
}

function dumphamp()
{
	var j;
	
	for (j = 0; j < hnum; j++)
		outlet (3, j+1,hamp[j]);
	post();
}

// --------------------- errors -------------------

// float
function msg_float(x)
{
	this.error("harmsum doesn't understand float");
	post();
}


// int
function msg_int(x)
{
	this.error("harmsum doesn't understand int");
	post();
}

// generic list
function list(val)
{
	this.error("list without command");
	x = arguments.length;
	for (var i=0; i < x; i++)
	{
		post (arguments[i]);
	}
	post();
}

